it.csi.mddtools.guigen

## Interface Widget

- All Superinterfaces:
    org.eclipse.emf.ecore.EObject, org.eclipse.emf.common.notify.Notifier
  All Known Subinterfaces:
    Button, Calendar, Captcha, CheckBox, ComboBox, CommandWidget, ConfirmButton, DataWidget, FileUpload, HiddenValue, Image, MapView, MenuView, MultiDataWidget, PlainText, RadioButton, RadioButtons, ResetButton, Slider, Table, TabSwitcher, TextArea, TextField, TreeView, UserDefinedWidget

      public interface Widget
      extends org.eclipse.emf.ecore.EObject

  A representation of the model object 'Widget'. Classe astratta dalla quale discendono tutti i vari tipi di widget.

  The following features are supported:

  - `Name`
  - `Label`
  - `Layout Spec`
  - `Event Handlers`
  - `Security Constraints`
  - `Default Visible`
  - `Default Enabled`
  - `Tooltip`
  - `Enable Enrichment`
  See Also:
    `GuigenPackage.getWidget()`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Boolean` | `getEnableEnrichment()` Returns the value of the 'Enable Enrichment' attribute
    `org.eclipse.emf.common.util.EList<EventHandler>` | `getEventHandlers()` Returns the value of the 'Event Handlers' containment reference list.
    `java.lang.String` | `getLabel()` Returns the value of the 'Label' attribute
    `WidgetLayoutSpecifier` | `getLayoutSpec()` Returns the value of the 'Layout Spec' containment reference
    `java.lang.String` | `getName()` Returns the value of the 'Name' attribute
    `org.eclipse.emf.common.util.EList<UISecurityConstraint>` | `getSecurityConstraints()` Returns the value of the 'Security Constraints' containment reference list.
    `java.lang.String` | `getTooltip()` Returns the value of the 'Tooltip' attribute
    `boolean` | `isDefaultEnabled()` Returns the value of the 'Default Enabled' attribute.
    `boolean` | `isDefaultVisible()` Returns the value of the 'Default Visible' attribute.
    `void` | `setDefaultEnabled(boolean value)` Sets the value of the '`Default Enabled`' attribute
    `void` | `setDefaultVisible(boolean value)` Sets the value of the '`Default Visible`' attribute
    `void` | `setEnableEnrichment(java.lang.Boolean value)` Sets the value of the '`Enable Enrichment`' attribute
    `void` | `setLabel(java.lang.String value)` Sets the value of the '`Label`' attribute
    `void` | `setLayoutSpec(WidgetLayoutSpecifier value)` Sets the value of the '`Layout Spec`' containment reference
    `void` | `setName(java.lang.String value)` Sets the value of the '`Name`' attribute
    `void` | `setTooltip(java.lang.String value)` Sets the value of the '`Tooltip`' attribute

    - ### Methods inherited from interface org.eclipse.emf.ecore.EObject

      `eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

    - ### Methods inherited from interface org.eclipse.emf.common.notify.Notifier

      `eAdapters, eDeliver, eNotify, eSetDeliver`

- - ### Method Detail

    - #### getName

          java.lang.String getName()

      Returns the value of the 'Name' attribute.

      If the meaning of the 'Name' attribute isn't clear, there really should be more of a description here...

      Codice identificativo del widget. Deve essere univoco all'interno del ContentPanel che lo contiene e deve essere un identificativo valido java.
      Returns:
        the value of the 'Name' attribute.
      See Also:
        `setName(String)`, `GuigenPackage.getWidget_Name()`

    - #### setName

          void setName(java.lang.String value)

      Sets the value of the '`Name`' attribute.
      Parameters:
        `value` - the new value of the 'Name' attribute.
      See Also:
        `getName()`

    - #### getLabel

          java.lang.String getLabel()

      Returns the value of the 'Label' attribute.

      If the meaning of the 'Label' attribute isn't clear, there really should be more of a description here...

      Etichetta associata al widget.
      Returns:
        the value of the 'Label' attribute.
      See Also:
        `setLabel(String)`, `GuigenPackage.getWidget_Label()`

    - #### setLabel

          void setLabel(java.lang.String value)

      Sets the value of the '`Label`' attribute.
      Parameters:
        `value` - the new value of the 'Label' attribute.
      See Also:
        `getLabel()`

    - #### getLayoutSpec

          WidgetLayoutSpecifier getLayoutSpec()

      Returns the value of the 'Layout Spec' containment reference.

      If the meaning of the 'Layout Spec' containment reference isn't clear, there really should be more of a description here...

      Specifica di posizionamento del widget all'interno del pannello che lo contiene. Il tipo dell'oggetto associato deve essere coerente con il tipo di layout del pannello contenitore.
      Returns:
        the value of the 'Layout Spec' containment reference.
      See Also:
        `setLayoutSpec(WidgetLayoutSpecifier)`, `GuigenPackage.getWidget_LayoutSpec()`

    - #### setLayoutSpec

          void setLayoutSpec(WidgetLayoutSpecifier value)

      Sets the value of the '`Layout Spec`' containment reference.
      Parameters:
        `value` - the new value of the 'Layout Spec' containment reference.
      See Also:
        `getLayoutSpec()`

    - #### getEventHandlers

          org.eclipse.emf.common.util.EList<EventHandler> getEventHandlers()

      Returns the value of the 'Event Handlers' containment reference list. The list contents are of type `EventHandler`.

      If the meaning of the 'Event Handlers' containment reference list isn't clear, there really should be more of a description here...

      Gestori degli eventi associati al widget. Le tipologie di evento gestite sono dipendenti dal particolare tipo di widget.
      Returns:
        the value of the 'Event Handlers' containment reference list.
      See Also:
        `GuigenPackage.getWidget_EventHandlers()`

    - #### getSecurityConstraints

          org.eclipse.emf.common.util.EList<UISecurityConstraint> getSecurityConstraints()

      Returns the value of the 'Security Constraints' containment reference list. The list contents are of type `UISecurityConstraint`.

      If the meaning of the 'Security Constraints' containment reference list isn't clear, there really should be more of a description here...

      E' possibile specificare uno o più security constraints sul widget, che permettono di rendere condizionata la visualizzazione o la abilitazione del widget a fronte delle condizioni descritte nel constraint. I constraint sono additivi (nel senso booleano) per ciascun constrained behavior (comportamento condizionato = {visibilità / abilitazione}): se almeno un constraint è verificato il comportamento condizionato sarà abilitato (visibilità / editabilità). Se nessun constraint sarà verificato, la visualizzazioen/abilitazione sarà condizionata solo allo stato di default / comandato, ovvero al valore delle proprietà defaultVisible o defaultEnabled se non è stato in precedenza utilizzato nessun comando di tipo ONOFFCommand o VisibilityCommand; se tali comandi sono stati utilizzati allora "vince" l'impostazione derivante da questi comandi. Se, infine, un constraint è verificato, comunque un eventuale disabilitazione/invisibilità comandata (tramite ONOFFCommand o VisibilityCommand) vince.
      Returns:
        the value of the 'Security Constraints' containment reference list.
      See Also:
        `GuigenPackage.getWidget_SecurityConstraints()`

    - #### isDefaultVisible

          boolean isDefaultVisible()

      Returns the value of the 'Default Visible' attribute. The default value is `"true"`.

      If the meaning of the 'Default Visible' attribute isn't clear, there really should be more of a description here...

      stato di visibilità di default del widget
      Returns:
        the value of the 'Default Visible' attribute.
      See Also:
        `setDefaultVisible(boolean)`, `GuigenPackage.getWidget_DefaultVisible()`

    - #### setDefaultVisible

          void setDefaultVisible(boolean value)

      Sets the value of the '`Default Visible`' attribute.
      Parameters:
        `value` - the new value of the 'Default Visible' attribute.
      See Also:
        `isDefaultVisible()`

    - #### isDefaultEnabled

          boolean isDefaultEnabled()

      Returns the value of the 'Default Enabled' attribute. The default value is `"true"`.

      If the meaning of the 'Default Enabled' attribute isn't clear, there really should be more of a description here...

      stato di abilitazione di default del widget
      Returns:
        the value of the 'Default Enabled' attribute.
      See Also:
        `setDefaultEnabled(boolean)`, `GuigenPackage.getWidget_DefaultEnabled()`

    - #### setDefaultEnabled

          void setDefaultEnabled(boolean value)

      Sets the value of the '`Default Enabled`' attribute.
      Parameters:
        `value` - the new value of the 'Default Enabled' attribute.
      See Also:
        `isDefaultEnabled()`

    - #### getTooltip

          java.lang.String getTooltip()

      Returns the value of the 'Tooltip' attribute. tooltip associato alla etichetta del widget
      Returns:
        the value of the 'Tooltip' attribute.
      See Also:
        `setTooltip(String)`, `GuigenPackage.getWidget_Tooltip()`

    - #### setTooltip

          void setTooltip(java.lang.String value)

      Sets the value of the '`Tooltip`' attribute.
      Parameters:
        `value` - the new value of the 'Tooltip' attribute.
      See Also:
        `getTooltip()`

    - #### getEnableEnrichment

          java.lang.Boolean getEnableEnrichment()

      Returns the value of the 'Enable Enrichment' attribute. Se impostato a true e se le features ricche sono abilitate (nella TargetPlatform) allora il widget sarà arricchito, altrimenti non sarà applicato nessun arricchimento. Il valore di default è true
      Returns:
        the value of the 'Enable Enrichment' attribute.
      See Also:
        `setEnableEnrichment(Boolean)`, `GuigenPackage.getWidget_EnableEnrichment()`

    - #### setEnableEnrichment

          void setEnableEnrichment(java.lang.Boolean value)

      Sets the value of the '`Enable Enrichment`' attribute.
      Parameters:
        `value` - the new value of the 'Enable Enrichment' attribute.
      See Also:
        `getEnableEnrichment()`